         btss   INTF1,ADCIF,ACCE
         jmp    Inter_3_out
         bcf    INTF1,ADCIF,ACCE
         mvff   ADCRL,ADNEWL
         mvff   ADCRM,ADNEWM
         mvff   ADCRH,ADNEWH
         bsf    RSTX,b_ADCkn,ACCE
         btsz   RAMFg,b_Regsp,ACCE
         jmp    INTADC_ADCEND
         btsz   RSTX,b_ADCcnn,ACCE
         jmp    INTADC_ADCEND
         btsz   RSTX,b_ADCbg,ACCE
         jmp    INTADC_ADCEND
         btsz   Flag,b_FlashW,ACCE
         jmp    INTADC_ADCEND
   ;--------------
      ;=====
      ; | - NEW|  --> ADCTEMP
      ; IF Negative then Flag.ADSign = 1
      ;=====
     INTADC_AVBegin: 
         mvf     ADNEWL,W,ACCE
         subf    ada1,W,ACCE
         mvf     ADCTEMP,F,ACCE
         mvf     ADNEWM,W,ACCE
         subc    ada1+1,W,ACCE
         mvf     ADCTEMP+1,F,ACCE
         mvf     ADNEWH,W,ACCE
         subc    ada1+2,W,ACCE
         mvf     ADCTEMP+2,F,ACCE
         bcf     Flag,ADSign,ACCE    
         btss    ADCTEMP+2,7,ACCE
         jmp     INTADC_AV1
         bsf     Flag,ADSign,ACCE    
         comf    ADCTEMP,F,ACCE
         comf    ADCTEMP+1,F,ACCE
         comf    ADCTEMP+2,F,ACCE
         mvl     1
         addf    ADCTEMP,F,ACCE  
         mvl     0
         addc    ADCTEMP+1,F,ACCE  
         addc    ADCTEMP+2,F,ACCE  
      INTADC_AV1:   
        ;===
        ;   | - NEW| < ADShiftbit ?
        ;   P_bit 10
        ;===
         tfsz    ADCTEMP+2,ACCE
         jmp     INTADC_OUTAV
         mvl     04h
         mvf     ADCTempBuf+1,F,ACCE
         mvl     0
         mvf     ADCTempBuf,F,ACCE  
         mvf     ADCTempBuf,W,ACCE
         subf    ADCTemp,W,ACCE
         mvf     ADCTempBuf+1,W,ACCE
         subc    ADCTemp+1,W,ACCE
         btsz    STATUS,C,ACCE
         jmp     INTADC_OUTAV
   ;====
   ;   (New + buf1 + buf2 + buf3 + buf4  + buf5 + buf6 + buf7) / 8 --> ada1        
   ;====      
         ldpr    ADBUF,FSR0
         mvl     0
         btsz    ADNEWH,7,ACCE
         mvl     0FFh
         mvf     ADCTemp,F,ACCE
         mvf     ADNEWL,W,ACCE
         addf    POINC0,W,ACCE
         mvf     ada1,F,ACCE
         mvf     ADNEWM,W,ACCE
         addc    POINC0,W,ACCE
         mvf     ada1+1,F,ACCE
         mvf     ADNEWH,W,ACCE
         addc    INDF0,W,ACCE
         mvf     ada1+2,F,ACCE
         mvl     0
         btsz    POINC0,7,ACCE
         mvl     0FFh
         addc    ADCTemp,F,ACCE
         
         mvl     6
         mvf     ADCTemp+1,F,ACCE
     INTADC_AV2LOOP:  
         mvf     POINC0,W,ACCE
         addf    ada1,F,ACCE
         mvf     POINC0,W,ACCE
         addc    ada1+1,F,ACCE
         mvf     INDF0,W,ACCE
         addc    ada1+2,F,ACCE
         mvl     0
         btsz    POINC0,7,ACCE
         mvl     0FFh
         addc    ADCTemp,F,ACCE
         dcsz    ADCTemp+1,F,ACCE
         jmp     INTADC_AV2LOOP

   ;====
   ;   New-->buf1-->buf2-->buf3-->buf4-->buf5-->buf6-->buf7        
   ;   ADCounter = 0
   ;====      
         ldpr    ADBUF+20,FSR0
         ldpr    ADBUF+17,FSR1
         mvl     6
     INTADC_AV3LOOP:    
         mvff    PODEC1,PODEC0
         mvff    PODEC1,PODEC0
         mvff    PODEC1,PODEC0
         dcsz    WREG,F,ACCE
         jmp     INTADC_AV3LOOP
         mvff    ADNEWH,PODEC0
         mvff    ADNEWM,PODEC0
         mvff    ADNEWL,PODEC0
         mvl     3
      INTADC_AD4LOOP:   
         bcf     STATUS,C,ACCE
         rrfc    ADCTemp,F,ACCE
         rrfc    ada1+2,F,ACCE
         rrfc    ada1+1,F,ACCE
         rrfc    ada1,F,ACCE
         dcsz    WREG,F,ACCE
         jmp     INTADC_AD4LOOP
         bcf     Flag,ADCounter,ACCE
         jmp     INTADC_AVEND
   ;========================================      
   INTADC_OUTAV:
       ;==
       ;  ADCounter = 0 ?  
       ;==         
         btss    Flag,ADCounter,ACCE
         jmp     INTADC_OUTAVONE
       ;==
       ;  S xor Sb = 0 ? O_PV
       ;  ADSignb = bit 2 
       ;==         
         mvl     00000000b
         btsz    Flag,ADSign,ACCE
         mvl     00000100b     
         xorf    Flag,W,ACCE
         andl    00000100b
         btsz    STATUS,Z,ACCE 
         jmp     INTADC_NEWAV
         jmp    INTADC_OUTAVONE
   ;===============================      
   INTADC_NEWAV:
     ;========
     ; Load New to buf1 ~ buf7
     ; Load New to 
     ; ADCounter = 0
     ;========
         ldpr    ADBUF,FSR0
         mvl     7
      INTADC_NEWAVLOOP:   
         mvff    ADNEWL,POINC0
         mvff    ADNEWM,POINC0
         mvff    ADNEWH,POINC0
         dcsz    WREG,F,ACCE
         jmp     INTADC_NEWAVLOOP
         mvff    ADNEWL,ada1
         mvff    ADNEWM,ada1+1
         mvff    ADNEWH,ada1+2
         bcf     Flag,ADCounter,ACCE
         jmp     INTADC_AVEND
   ;===============================      
   INTADC_OUTAVONE:      
   ;==
   ;  NEW --> LATCH 
   ;==      
         bcf     Flag,ADSignb,ACCE    
         btsz    Flag,ADSign,ACCE    
         bsf     Flag,ADSignb,ACCE    
         mvff    ADNEWH,ADLatchH        
         mvff    ADNEWM,ADLatchM        
         mvff    ADNEWL,ADLatchL  
         bsf     Flag,ADCounter,ACCE      
INTADC_AVEND:
         mvff    ADA1,ADCOUTL         
         mvff    ADA1+1,ADCOUTM         
         mvff    ADA1+2,ADCOUTH
         ;bcf     STATUS,C,ACCE
         ;rlfc    ADCOUTL,F,ACCE
         ;rlfc    ADCOUTM,F,ACCE
         ;rlfc    ADCOUTH,F,ACCE
         ;bcf     ADCOUTH,7,ACCE
         ;btsz    STATUS,C,ACCE
         ;bsf     ADCOUTH,7,ACCE
         ;tfsz    ADshiftbit,ACCE
         ;jmp     INTADC_AVEND1
         ;jmp     INTADC_AVEND2
      ;INTADC_AVEND1: 
	mvl	0
	cpsg	ADshiftbit,ACCE
	jmp	INTADC_AVEND2 
         mvf     ADshiftbit,W,ACCE
      INTADC_AVENDLOOP:   
         bcf	status,C,ACCE
         btsz    ADA1+2,7,ACCE
         bsf	status,C,ACCE
         rrfc    ADCOUTH,F,ACCE
         rrfc    ADCOUTM,F,ACCE
         rrfc    ADCOUTL,F,ACCE
         dcsz    WREG,F,ACCE
         jmp     INTADC_AVENDLOOP
      INTADC_AVEND2:   
         bsf     ADCFg,b_ADCint,ACCE
         bsf     Flag,b_ADCPCOK,ACCE
INTADC_ADCEND:                   
;=========================================================================================
         btss   RAMFg,b_Regsp,ACCE
         jmp    Inter_ADCFlashPRO
         btsz   RAMFg,b_Regspbg,ACCE
         jmp    Inter_ADCSTPPRO
      Int_ADCSTPPR0:   
         lbsr   STEPBF
         clrf   STEPBF,BANK
      Int_ADCSTPPR1:   
         mvff   STEPLEN,STEPLENBF
         lbsr   STEPBF
         bcf    STATUS,C,ACCE
         rlfc   STEPBF,W,BANK
         bcf    STATUS,C,ACCE
         rlfc   WREG,F,ACCE
         bcf    STATUS,C,ACCE
         rlfc   WREG,F,ACCE
         addl   REGData0
         mvf    FSR1L,F,ACCE
         mvl    HIGH REGData0
         mvf    FSR1H,F,ACCE
         clrf   FSR0H,ACCE
         lbsr   Steptemp
         clrf   Steptemp,BANK
    Inter_ADCSTPBGLOP:     
         mvl    REGAddr
         addf   Steptemp,W,BANK
         mvf    FSR0L,F,ACCE
         mvl    HIGH REGAddr
         mvf    FSR0H,F,ACCE
         mvf    INDF0,W,ACCE
         mvf    FSR0L,F,ACCE
         clrf   FSR0H,ACCE
        ; mvff   REGAddr,FSR0L
         mvff   POINC1,INDF0 
        ; mvff   REGAddr,FSR0L
         inf    StepTemp,F,BANK
         btss   Steptemp,3,BANK
         jmp    Inter_ADCSTPBGLOP
         btsz   RAMFg,b_Regspbg,ACCE
         jmp    Inter_ADC_WDF
         bsf    RAMFg,b_Regspbg,ACCE
         bcf    RAMFg,b_Regspok,ACCE
         jmp    Inter_3_out
     Inter_ADCSTPPRO:
         lbsr   STEPLENBF
         dcsz   STEPLENBF,F,BANK
         jmp    Inter_ADC_WDF
         inf    STEPBF,F,BANK
         mvf    STEP,W,BANK
         cpse   STEPBF,BANK
         jmp    Int_ADCSTPPR1
         mvl    1
         subf   LOOPLEN,F,BANK
         mvl    0
         subc   LOOPLEN+1,F,BANK
         tfsz   LOOPLEN+1,BANK
         jmp    Int_ADCSTPPR0
         tfsz   LOOPLEN,BANK
         jmp    Int_ADCSTPPR0
         bsf    RAMFg,b_Regspok,ACCE
         bcf      RAMFg,b_Regsp,ACCE
         jmp    Inter_ADC_WDF
         ;jmp    Inter_3_out
;---------
   Inter_ADCFlashPRO:
         btss   Flag,b_FlashW,ACCE
         jmp    Inter_ADCNX
         lbsr   FlashGvup
         tfsz   FlashGvup,BANK
         jmp    Inter_ADCFlashGV
         jmp    Inter_ADCFlash
      Inter_ADCFlashGV:   
         dcsz   FlashGvup,F,BANK
         jmp    Inter_3_out
      Inter_ADCFlash:   
         lbsr   FlashLen
         btss   FlashLen+2,7,BANK
         jmp    Inter_ADCNX1
        Inter_ADCNXOUT: 
         bsf    Flag,b_FlashOK,ACCE
         jmp    Inter_3_out
      Inter_ADCNX1:
         mvl     0
         cpse    FlashLen+2,BANK
         jmp     Inter_ADCNX2
         cpse    FlashLen+1,BANK
         jmp     Inter_ADCNX2
         cpse    FlashLen,BANK
         jmp     Inter_ADCNX2
         jmp     Inter_ADCNXOUT
     Inter_ADCNX2:    
         jmp    Inter_ADC_WDF
      Inter_ADCNX:   
         btss   RSTX,b_ADCcnn,ACCE
         jmp    Inter_ADC_A
         tfsz   GvupADC,ACCE
         jmp    Inter_ADC_w1
         jmp    Inter_ADC_w3
      Inter_ADC_w1:   
         insz   GvupADC,F,ACCE
         jmp    Inter_ADC_A
      Inter_ADC_w3:   
         mvff   RAMBKL,FSR0L
         mvff   RAMBKH,FSR0H
         mvf    ADNEWL,W,ACCE
         mvf    POINC0,F,ACCE
         mvf    ADNEWM,W,ACCE
         mvf    POINC0,F,ACCE
         mvf    ADNEWH,W,ACCE
         mvf    POINC0,F,ACCE
         mvl    1
         cpse   FSR0H,ACCE
         jmp    Inter_ADC_w2
         mvl    7Dh
         cpsg   FSR0L,ACCE
         jmp    Inter_ADC_w2
         mvl    1
         mvf    FSR0H,F,ACCE
         mvf    RAMBKH,F,ACCE
         clrf   FSR0L,ACCE
         clrf   RAMBKL,ACCE 
         bcf     RSTX,b_ADCcnn,ACCE
         mvl      256-3 
         mvf      GvupADC,F,ACCE
         jmp    Inter_3_out
       Inter_ADC_w2:  
         mvff   FSR0L,RAMBKL
         mvff   FSR0H,RAMBKH
    ;-------------------------     
    Inter_ADC_A:     
         btsz   RSTX,b_ADCbg,ACCE
         jmp    Inter_ADC_WDF
       mvl     low  SaveData
       mvf     RAMClient,F,ACCE
       mvf     RAMStart,F,ACCE
         
         jmp     Inter_3_2
      Inter_ADC_WDF:   
         bcf    RAMFg,bClient,ACCE
         bcf    RAMFg,bClient1,ACCE
         mvf    RAMStart,W,ACCE
         subf   RAMClient,W,ACCE
         btss   status,c,ACCE
         addl   SaveDataend - SaveData + 1
         addl   256 - SaveDataend + SaveData + 1       
         btsz   status,c,ACCE
         jmp    ttt
      Inter_3_Loop:        
         mvf    RAMClient,W,ACCE
         mvf    FSR0L,F,ACCE
         mvl    High  SaveData
         mvf    FSR0H,F,ACCE
         btsz   RAMFg,bClient1,ACCE
         jmp    Inter_ADC_SA
         mvf    ADNEWL,W,ACCE
         btsz   RAMFg,bClient,ACCE
         mvf    ADNEWM,W,ACCE
         jmp    Inter_ADC_SB
       Inter_ADC_SA:
         mvf    ADNEWH,W,ACCE
       Inter_ADC_SB:  
         mvf    INDF0,F,ACCE
         inf    RAMClient,F,ACCE
         mvl    LOW  SaveData
         subf   RAMClient,W,ACCE
         addl   256 - SaveDataend + SaveData - 1       
         btss   status,c,ACCE
         jmp    Inter_3_1
         mvl    LOW  SaveData
         mvf    RAMClient,F,ACCE
     Inter_3_1: 
         btsz   RAMFg,bClient1,ACCE
         jmp    Inter_ADC_SC
         btsz   RAMFg,bClient,ACCE
         jmp    Inter_ADC_SD
         bsf    RAMFg,bClient,ACCE
         jmp    Inter_3_Loop
       Inter_ADC_SD:
         bsf    RAMFg,bClient1,ACCE
         jmp    Inter_3_Loop
     Inter_ADC_SC:
         btss   Flag,b_FlashW,ACCE
         jmp    Inter_3_2
         mvl     3
         subf    FlashLen,F,BANK
         mvl     0
         subc    FlashLen+1,F,BANK
         subc    FlashLen+2,F,BANK  
         jmp     Inter_3_2
       ttt:  
          nop
      Inter_3_2:   
     Inter_3_out:    
