;=======================================
;SPIϥΨ쪺Register
;    SPICNT      1 byte
;    SPIM        1 byte
;    SPIINDEXH   1 byte
;    SPIINDEXL   1 byte
;    RSLEN       1 byte
;    RSTX        1 byte
;=======================================
FSR0HTemp    equ    0FFH
FSR0LTemp    equ    0FEh   ; 0FE
FSR1HTemp    equ    0FDh   ;0FD
FSR1LTemp    equ    0FCh     ;0FC
SPICNT       equ    0FBh   ;0FB
SPIM         equ    0FAh      ;0FA
        bWRD   equ   7
SPIINDEXH    equ    0F9h        ;0F9  
SPIINDEXL    equ    0F8h   ;0F8
SPIDATA      equ    0F7h   ;0F7
RSLEN        equ    0F1h    ;0F1
sn	equ	0F5h
ADCOUTH      equ    0F6h
ADCOUTM      equ    0F3h
ADCOUTL      equ    0F2h
RSTX         equ    0F0h       ;0F0
   b_ANTX    equ    0
   b_ADCbg   equ    1    ; Catch ADC
   b_ADCcnn  equ    2
   b_ADCkn   equ    3
   b_tm      equ    4
   b_rdEEPROM  equ  5
   b_wrEEPROM  equ  6
   b_EEPROMERR equ  7
;==========================================================
MD1          equ    80h
dsp          equ    MD1
dsp1         equ    dsp+6
VSQRT        equ    MD1     ;80
s_reg_EE     equ    MD1
eeaddress    equ    MD1+1
temr         equ    eeaddress+1
eedatemp     equ    temr+1
r_Len_EE     equ    eedatemp+1
SQRTBuf      equ    MD1+4
RSQRT        equ    MD1+8 
MD2          equ    MD1+1   ;81
MD3          equ    MD2+1   ;82
MDL1         equ    MD3+1   ;83
MDL2         equ    MDL1+1  ;84
MDL3         equ    MDL2+1  ;85
MD4          equ    MDL3+1  ;86
S_REG        equ    MD4+6   ;8D
r_Len        equ    S_REG+1 ;8E
SQRTmp       equ    r_Len+1 ;8F
WeightBuf    equ    SQRTmp
Temp         equ    SQRTmp+4;92 
ADAZ1H       equ    Temp+11 ; 9Dh
TareH        equ    Temp+12 ; 9Eh
ZeroH        equ    Temp+13 ; 9Fh
ADCMaxH      equ    Temp+14 ; 0A0h
PreZeroH     equ    Temp+15 ; 0A1h

RAMClient    equ    Temp+16   ; 0A2
RAMStart     equ    RAMClient+1   ; 0A3
RAMFg        equ    RAMStart+1    ; 0A4   
   bClient   equ    0
   bStart    equ    1
   bClient1  equ    2
   b_FlashR  equ    3
   b_Regsp   equ    4
   b_Regspbg equ    5
   b_Regspok equ    6
   
RAMBKL        equ     RAMFG+1     ; 0A5h   
RAMBKH        equ     RAMBKL+1    ; 0A6h
Tm            equ    RAMBKH+1     ; 0A7
Aub           equ    Tm+1         ; 0A8
ADCFg         equ    Aub          ; 0A8
   bg         equ    0
   b_ADCint   equ    1
   b_neg      equ    2
   b_stable   equ    3
   b_nonevalue   equ   4
   b_ADCOK    equ    5
   b_Tarem     equ    6
   b_Zerom     equ    7
ADCTemp        equ    0A9h
KeyFlash     equ     0ACh
ADshiftbit    equ    ADCTemp+4
ADLatchH      equ     ADCTemp+5
ADA1          equ    0AFh         ; 0AF
;ADA0          equ    ADA1+3       ; 0B2
ADStable     equ     0B2h        ; 0B2
ADAZH        equ     0b5h        ;0B5h                                
eecnt        equ     0B6h         ; 0B6
ADStbcnt     equ     eecnt+1      ; 0B7
KeyStill     equ     ADStbcnt+1   ; 0B8
KeyCnt       equ     KeyStill+1   ; 0B9 
UWeight      equ     KeyCnt+1     ; 0BA
CWeight      equ     UWeight+2    ; 0BC
ADPoint      equ     CWeight+2;   ; 0BE
ADAZ         equ     ADPoint+1    ; 0BF
ADSPAN       equ     ADAZ+2       ; 0C1
ADSPANH      equ     ADSPAN+2 ;   ; 0C3
ADSPANU      equ     ADSPANH+1 ;   ; 0C4

ADAZ1        equ     ADSPANU+1         ; 0C5
Tare         equ     ADAZ1+2      ; 0C7
Zero         equ     Tare+2       ; 0C9
ADShift      equ     Zero+2       ; 0CB
ADLatchL      equ    ADShift+1
ADLatchM      equ    ADLatchL+1
Tm1s         equ     ADShift+2    ; 0CD
ADCMax       equ     Tm1S+1       ; 0CE
PreZero      equ     ADCMax+2     ; 0D0
Flag         equ     PreZero+2    ; 0D2
   b_ADS     equ     0
   ADSign    equ     1
   ADSignb   equ     2
   ADCounter equ     3  
   b_ADCPCOK equ     4  
   b_FlashW   equ     5
   b_FlashOK  equ     6
   b_FlashEr  equ   7
   
GvupADC         equ  Flag+1       ; 0D3
ADNEWL       equ     GvupADC+1    ; 0D4
ADNEWM       equ     ADNEWL+1
ADNEWH        equ    ADNEWM+1
ADBUF        equ     ADNEWH+1      ; 0D7
ADCTempBuf    equ     ADBUF+21     ; 0EC
;0eeh, 0efh not used
Flag1	equ	0EEh
	b_initz	equ	0
	b_keyz	equ	1
	b_keyt	equ	2
	b_E2	equ	3
;==========================================================
ScalData1    equ    0100h   ; ˸m1O϶ form 0x140 ~ 0x17F  MgMainData
PORTCOUNT    equ    0100h
SaveData     equ    0100h   ; sxO϶ form 0x120 ~ 0x17F @48 
SaveDataend  equ    011Fh
STEPLEN      equ    0120h
STEPLENBF    equ    0121h
LOOPLEN      equ    0122h
STEP         equ    0124h
STEPBF       equ    0125h
Steptemp     equ    0126h
REGAddr      equ    0128h
REGData0     equ    0130h
REGData1     equ    0138h
REGData2     equ    0140h
REGData3     equ    0148h
REGData4     equ    0150h
REGData5     equ    0158h
REGData6     equ    0160h
REGData7     equ    0168h
FlashAddr    equ    0170h
FlashLen     equ    0173h
FlashData    equ    0176h
FlashGvup    equ    0177h
;==================================================
KeyPT      equ     PT1
       bK1         equ   0
       bK2         equ   3
KeyPT2     equ     PT2        
       bK3         equ   4   
;====================================
LCD_TRACE	equ	LCD8
       b_TRACE       equ	0 
RLCDG      equ     LCD6
       b_lbat       equ    0
       b_lneg       equ    4
       b_ltare      equ    5
       b_zero       equ    6    
     ;  b_lg         equ    4         
       b_loz        equ    5         
       b_ldwt       equ    6         
       b_lozt       equ    7  
LCD_G      equ     LCD5
       b_lg         equ    7              
UNITLCD7    EQU     LCD7
      b_MM      equ 0
      b_K       equ 4
      b_A       equ 5
      b_R       equ 6
      b_V       equ 7

UNITLCD6    EQU     LCD6
      b_lb1     equ 0
      b_lb2     equ 1
      b_lb3     equ 2
      b_lb4     equ 3 
      b_negative    equ 4 
      b_m       equ 7  
      
;UNITC   EQU     00AH    ;LCD7
;UNITF   EQU     006H    ;LCD7
;===================================================
pt2en         equ     TRISC2
eeclk            equ    2
eedata           equ    3
ptclkem           equ    pt2en     ; 0 input  , 1 output
ptdaem         equ     pt2en
ptda             equ    pt2
ptclk            equ    pt2
;======================================================
FSPIDIEN        equ     TRISC2
FSPIDIPU        equ     PT2PU
FSPIDI          equ     PT2
                bSPIDI      equ     4 
FSPIDOEN        equ     TRISC1
FSPIDOPU        equ     PT1PU
FSPIDO          equ     PT1
                bSPIDO      equ     3
FSPICKEN        equ     TRISC1
FSPICKPU        equ     PT1PU
FSPICK          equ     PT1
                bSPICK      equ     7
FSPICSEN        equ     TRISC1
FSPICSPU        equ     PT1PU
FSPICS          equ     PT1
                bSPICS      equ     4

FSR0			EQU		0
FSR1			EQU		1                 